﻿//===============================================================================
// Q4Tech Engineering Team
// Mobile Updater Application Block - November 2006
//===============================================================================
// Copyright  Q4Tech Informatica Argentina.  All rights reserved.
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY
// OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT
// LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
// FITNESS FOR A PARTICULAR PURPOSE.
//===============================================================================
// The example companies, organizations, products, domain names,
// e-mail addresses, logos, people, places, and events depicted
// herein are fictitious.  No association with any real company,
// organization, product, domain name, email address, logo, person,
// places, or events is intended or should be inferred.
//===============================================================================

using System;

namespace Q4Tech.Engineering.Ipc
{
    public interface IPointToPointMessageQueue : IDisposable
    {
        void Close();
        int Count { get; }
        byte[] Dequeue();
        byte[] Dequeue(uint timeout);
        int Dequeue(ref byte[] buffer);
        void Enqueue(byte[] buffer);
        void Initialize(string name, Ipc.PointToPointMessageQueue.AccessMode accessMode, int maxMessageSize, int maxMessageCount);
        string Name { get; }
        bool RemotePeerPresent { get; }
        void Purge();
    }
}
