//===============================================================================
// Q4Tech Engineering Team
// Mobile Updater Application Block - November 2006
//===============================================================================
// Copyright  Q4Tech Informatica Argentina.  All rights reserved.
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY
// OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT
// LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
// FITNESS FOR A PARTICULAR PURPOSE.
//===============================================================================
// The example companies, organizations, products, domain names,
// e-mail addresses, logos, people, places, and events depicted
// herein are fictitious.  No association with any real company,
// organization, product, domain name, email address, logo, person,
// places, or events is intended or should be inferred.
//===============================================================================

using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Practices.Mobile.Configuration;

namespace Q4Tech.Engineering.UpdaterAgent.Configuration
{
	public class UpdaterConfigurationSection : ConfigurationSection
	{
		public const string SectionName = "UpdaterConfiguration";

		public static UpdaterConfigurationSection GetSection()
		{
			return (UpdaterConfigurationSection)ConfigurationManager.GetSection(SectionName);
		}

		[ConfigurationProperty("manifestListUri")]
		public string ManifestListUri
		{
			get { return (string)this["manifestListUri"]; }
			set { this["manifestListUri"] = value; }
		}

        [ConfigurationProperty("defaultDownloader")]
        public string DefaultDownloader
        {
            get { return (string)this["defaultDownloader"]; }
            set { this["defaultDownloader"] = value; }
        }

        [ConfigurationProperty("downloaders")]
        public DownloadersElementCollection Downloaders
        {
            get { return (DownloadersElementCollection)this["downloaders"]; }
            set { this["downloaders"] = value; }
        }

        [ConfigurationProperty("updateInterval")]
        public string UpdateInterval
        {
            get { return (string)this["updateInterval"]; }
            set { this["updateInterval"] = value; }
        }

        [ConfigurationProperty("manifestManager")]
        public ManifestManagerElement ManifestManager
        {
            get { return (ManifestManagerElement)this["manifestManager"]; }
            set { this["manifestManager"] = value; }
        }

        [ConfigurationProperty("deviceIdProviders")]
        public DeviceIdProvidersCollection DeviceIdProviders
        {
            get { return (DeviceIdProvidersCollection)this["deviceIdProviders"]; }
            set { this["deviceIdProviders"] = value; }
        }

        [ConfigurationProperty("deviceIdProvider")]
        public string DefaultDeviceIdProvider
        {
            get { return (string)this["deviceIdProvider"]; }
            set { this["deviceIdProvider"] = value; }
        }
	}
}
