//===============================================================================
// Q4Tech Engineering Team
// Mobile Updater Application Block - November 2006
//===============================================================================
// Copyright  Q4Tech Informatica Argentina.  All rights reserved.
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY
// OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT
// LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
// FITNESS FOR A PARTICULAR PURPOSE.
//===============================================================================
// The example companies, organizations, products, domain names,
// e-mail addresses, logos, people, places, and events depicted
// herein are fictitious.  No association with any real company,
// organization, product, domain name, email address, logo, person,
// places, or events is intended or should be inferred.
//===============================================================================

using System;
using Q4Tech.Engineering.UpdaterAgent.Management;
using Microsoft.WindowsMobile.Status;
namespace Q4Tech.Engineering.UpdaterAgent.UpdaterView
{
    public class BoolEventArgs : EventArgs
    {
        private bool boolValue;

        public BoolEventArgs(bool boolValue)
        {
            this.boolValue = boolValue;
        }

        public bool Value
        {
            get { return boolValue; }
            set { boolValue = value; }
        }
    }

    public interface IUpdaterView
    {
        event EventHandler ForceUpdate;
        event EventHandler ViewDeviceID;
        event EventHandler<BoolEventArgs> VerboseCheck;
        event EventHandler LoadView;
        event EventHandler<ChangeEventArgs> OrientationChange;
        event EventHandler<BoolEventArgs> ActiveView;

        bool ForceUpdateEnabled { set;}
        string MessageLog { get;set;}
        bool VerboseSet { set;}
        void SetStatus(bool connected, int pendingDownloads);
        void WriteLine(string message);
        void Hide();
        void Show();
    }
}
