﻿using System;
using System.Windows.Forms;

namespace EditUsers_Best
{
    /// <summary>
    /// Basic interface used by the <see cref="ITaskService"/> to 
    /// show the views.
    /// </summary>
    public interface IView
    {
        DialogResult ShowDialog();
    }

    /// <summary>
    /// Extended typed interface for views that 
    /// need a reference to its presenter.
    /// </summary>
    public interface IView<TPresenter> : IView
    {
        /// <summary>
        /// The presenter instance.
        /// </summary>
        TPresenter Presenter { get; set; }
    }
}

