﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using EditUsers_Poor;

namespace EditUsers_Poor
{
    public partial class ManageUsersView : Form
    {
        public ManageUsersView()
        {
            InitializeComponent();
        }

        private void btnSearch_Click(object sender, EventArgs e)
        {
            if (!String.IsNullOrEmpty(txtSearch.Text))
            {
                userBindingSource.Filter = "FirstName LIKE '*" + txtSearch.Text + "*' OR " +
                      "LastName LIKE '*" + txtSearch.Text + "*'";
            }
            else
            {
                userBindingSource.RemoveFilter();
            }
        }

        private void btnSave_Click(object sender, EventArgs e)
        {
            // Create/save the currently selected record
            // Note: the View has a BindingSource control called userBindingSource that is bound to a UsersDataSet object
            // using data binding, and the three TextBox controls at the bottom of the screen 
            // are bound to userBindingSource - hence work on the currently selected record in the Users collection 
            this.userBindingSource.EndEdit();

            // Get grid to redraw itself
            this.userDataGrid.Refresh();
        }

        public void SetStatus(string status)
        {
            this.statusBar.Text = status;
        }

        private void EnableEditControls(bool enableIt)
        {
            this.txtFirstName.Enabled = enableIt;
            this.txtLastName.Enabled = enableIt;
            this.txtUsername.Enabled = enableIt;
            this.btnSave.Enabled = enableIt;
        }

        private void btnNew_Click(object sender, EventArgs e)
        {
            // Create a new user
            this.userBindingSource.AllowNew = true;
            this.userBindingSource.AddNew();
            EnableEditControls(true);
            txtUsername.Focus();
        }

        private void userBindingSource_PositionChanged(object sender, EventArgs e)
        {
            EnableEditControls(userBindingSource.Position > -1);
        }
    }
}