﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace EventAggregationQuickStart
{
    /// <summary>
    /// Basic interface used by the <see cref="IRegionManagerService"/> to 
    /// show the views.
    /// </summary>
    public interface IView
    {
    }

    /// <summary>
    /// Extended typed interface for views that 
    /// need a reference to its presenter.
    /// </summary>
    public interface IView<TPresenter> : IView
    {
        /// <summary>
        /// The presenter instance.
        /// </summary>
        TPresenter Presenter { get; set; }
    }
}
